/* #define HEAT 1 */
/*
 * pattern2n-adi-BZ.c --- 2ĹΰˤBZȿ(Neumann ) 
 *                  ADI ˡǲ򤯡
 *
 *   ѥ뤹ˤ
 *     gcc -c trid-lu.c
 *     gcc -o pattern2n-adi-BZ pattern2n-adi-BZ.c trid-lu.o -lmatrix -lglscd -lX11 -lm
 *   or
 *     ccmg pattern2n-adi-BZ.c 
 */

#include <stdio.h>
#include <math.h>
#include <matrix.h>
#define G_DOUBLE
#include <glsc.h>

double PI;

double u0(double,double,double,double,int);
double v0(double,double,double,double,int);
double beta(double,double);
void trilu0(int n, double *al, double *ad, double *au);
void trisol0(int n, double *al, double *ad, double *au, double *b);
void drawSwing_max(double U_max[], double V_max[], int l);
void drawSwing_min(double U_min[], double V_min[], int l);
void drawSwing_ave(double U_ave[], double V_ave[], int l);
void drawCycle(double U_ave[], double V_ave[], int l);

main()
{
    double a, b, c, d, c1_u, c1_v, c2_u, c2_v, c3_u, c3_v,
    c4_u, c4_v, c5_u, c5_v, c6_u, c6_v, c7_u, c7_v, c8_u, c8_v;
    int N_x, N_y, i, j, k, m, kmax, skip, nfunc;
    int l=0;
    double h_x, h_y, lambda_x_u, lambda_y_u, lambda_x_v, lambda_y_v, lambda_u, lambda_v,
    tau, Tmax, dt,Du,Dv,epsilon,f,q,steady;
    double u_max,u_min,v_max,v_min, du, dv;
    double U_max[101],V_max[101],U_min[101],V_min[101],U_ave[101],V_ave[101];
    double U_sum,V_sum;
    double *alx_u, *adx_u, *aux_u, *aly_u, *auy_u, *ady_u, *alx_v, *adx_v, *aux_v, *aly_v, *auy_v, *ady_v, *ff, *gg;
    matrix U, newU, V, newV;
    double F(double, double, double, double, double), G(double, double);
    char message1[100],message2[100];
    double t=0.0;

    Du=0.1;
    Dv=0.06;
    epsilon=4e-2;
    f=0.5;
    q=8e-4;

    printf("f="); scanf("%lf",&f);
    printf("q="); scanf("%lf",&q);

    steady=(1-f-q+sqrt((f+q-1)*(f+q-1)+4*q*(1+f)))/2;

    printf("ʿ=%g\n", steady);

    printf("="); scanf("%lf",&epsilon);

    PI=4*atan(1.0);

     /* Ĺΰ */
    a = 0.0; b = 2.0; c = 0.0; d = 1.5;
    printf("b="); scanf("%lf",&b);
    printf("d="); scanf("%lf",&d);

    /* ʬη */
    printf("Nx,Ny: "); scanf("%d %d", &N_x, &N_y);

    h_x = (b - a) / N_x;
    h_y = (d - c) / N_y;

    /* ٥ȥ롢򵭲뤿ѿν */
    if ((alx_u = (double *) malloc(N_x * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate alx_u[]\n");
	exit(1);
    }
    if ((adx_u = (double *) malloc(N_x * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate adx_u[]\n");
	exit(1);
    }
    if ((aux_u = (double *) malloc(N_x * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate aux_u[]\n");
	exit(1);
    }
    if ((aly_u = (double *) malloc(N_y * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate aly_u[]\n");
	exit(1);
    }
    if ((ady_u = (double *) malloc(N_y * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate ady_u[]\n");
	exit(1);
    }
    if ((auy_u = (double *) malloc(N_y * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate auy_u[]\n");
	exit(1);

    }
    if ((alx_v = (double *) malloc(N_x * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate alx_v[]\n");
	exit(1);
    }
    if ((adx_v = (double *) malloc(N_x * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate adx_v[]\n");
	exit(1);
    }
    if ((aux_v = (double *) malloc(N_x * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate aux_v[]\n");
	exit(1);
    }
    if ((aly_v = (double *) malloc(N_y * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate aly_v[]\n");
	exit(1);
    }
    if ((ady_v = (double *) malloc(N_y * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate ady_v[]\n");
	exit(1);
    }
    if ((auy_v = (double *) malloc(N_y * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate auy_v[]\n");
	exit(1);
    }
    if ((ff = (double *) malloc(N_x * sizeof(double))) == NULL) {
	fprintf(stderr, "cannot allocate ff[]\n");
	exit(1);
    }
    if ((gg = (double *) malloc(N_y * sizeof(double))) == NULL) {
      fprintf(stderr, "cannot allocate gg[]\n");
      exit(1);
    }
    if ((U = new_matrix(N_x + 1, N_y + 1)) == NULL) {
      fprintf(stderr, " newU 򵭲ΰγݤ˼\n");
      exit(1);
    }
    if ((newU = new_matrix(N_x + 1, N_y + 1)) == NULL) {
      fprintf(stderr, " U 򵭲ΰγݤ˼\n");
      exit(1);
    }
    if((V = new_matrix(N_y+1,N_y+1))==NULL){
      fprintf(stderr," newV 򵭲ΰγݤ˼\n");
      exit(1);
    }
    if ((newV = new_matrix(N_x + 1, N_y + 1)) == NULL) {
      fprintf(stderr, " V 򵭲ΰγݤ˼\n");
      exit(1);
    }

    /* ֹη */
    printf("(۲ˡξΰΤξ=%g): ",
	   0.5 / (1/(2*h_x*h_x)+1/(2*h_y*h_y)));
    scanf("%lf", &tau);

    /* ǽη */
    printf("Tmax: "); scanf("%lf", &Tmax);

    /* ѥ᡼η׻ */
    lambda_x_u = Du*tau / (2 * h_x * h_x);
    lambda_y_u = Du*tau / (2 * h_y * h_y);
    lambda_u = lambda_x_u + lambda_y_u;

    lambda_x_v = Dv*tau / (2 * h_x * h_x);
    lambda_y_v = Dv*tau / (2 * h_y * h_y);
    lambda_v = lambda_x_v + lambda_y_v;

    /* դ褹ֳִ֤η */
    printf("dt: "); scanf("%lf", &dt);
    printf("nfunc="); scanf("%d", &nfunc);
    skip = dt / tau;


    /* դν (GLSC ν¾) */
    g_init("PATTERN",270.0, 195.0);
    g_device(G_BOTH);

    g_def_scale(0,
		0.0, 1.0, 0.0, 1.0,
		20.0, 110.0, 60.0, 60.0);
    g_def_scale(1,
		0.0, 1.0, 0.0, 1.0,
		105.0, 110.0, 60.0, 60.0);
    g_def_scale(2,
		0.0, 1.0, 0.0, 1.0,
		190.0, 20.0, 60.0, 30.0);
    g_def_scale(3,
		0.0, 1.0, 0.0, 1.0,
		190.0, 55.0, 60.0, 30.0);
    g_def_scale(4,
		0.0, 1.0, 0.0, 1.0,
		190.0, 90.0, 60.0, 30.0);
    g_def_scale(5,
		0.0, 1.0, 0.0, 1.0,
		190.0, 125.0, 60.0, 60.0);

    g_def_line(0,G_BLACK,0,G_LINE_DOTS);
    g_def_line(1,G_RED,0,G_LINE_SOLID);
    g_def_line(2,G_BLUE,0,G_LINE_SOLID);
    g_def_line(3,G_GREEN,0,G_LINE_SOLID);
    g_def_text(0,G_BLACK,2);
    g_def_text(1,G_RED,1);
    
    /*  */
    for (i = 0; i <= N_x; i++) 
      for (j = 0; j <= N_y; j++){
	U[i][j] = u0(a + i * h_x, c + j * h_y, steady, q, nfunc);
	V[i][j] = v0(a + i * h_x, c + j * h_y, steady, q, nfunc);
      }

    /* Υդ */
    g_cls();
    
    sprintf(message1,"f=%g, q=%g, steady=%g, epsilon=%g, b=%g, d=%g, Nx=%d, Ny=%d, Tmax=%g, dt=%g,",f,q,steady,epsilon,b,d,N_x,N_y,Tmax,dt);
    sprintf(message2,"nfunc=%d, t=%g",nfunc,t);
    g_sel_text(0);
    g_text(5.0,10.0,message1);
    g_text(5.0,20.0,message2);
      
    /* g_sel_text(1);
       g_text(19,82,"0");
       g_text(18,69,"1");
       g_text(93,102,"1");
       g_text(144,82,"0");
       g_text(143,69,"1"); 
       g_text(218,102,"1");*/

    u_max=u_min=U[0][0];
    v_max=v_min=V[0][0];
    for(i=0;i<=N_x;i++)
      for(j=0;j<=N_y;j++){
	if(U[i][j]>u_max)u_max=U[i][j];
	if(U[i][j]<u_min)u_min=U[i][j];
	if(V[i][j]>v_max)v_max=V[i][j];
	if(V[i][j]<v_min)v_min=V[i][j];
      }
    printf("u_max=%e,u_min=%e,v_max=%e,v_min=%e\n",u_max,u_min,v_max,v_min);

    U_max[l]=u_max;
    V_max[l]=v_max;
    U_min[l]=u_min;
    V_min[l]=v_min;

    U_sum=V_sum=0.0;

    for(i=0;i<=N_x;i++)
      for(j=0;j<=N_y;j++){
	U_sum+=U[i][j];
	V_sum+=V[i][j];
      }
    
    U_ave[l]=U_sum/((N_x+1)*(N_y+1));
    V_ave[l]=V_sum/((N_x+1)*(N_y+1));
    
    g_hidden2(1.0, 1.0, 0.4, u_min, u_max,
	      5.0, 25.0, 30.0,
	      10.0, 20.0, 80.0, 60.0,
	      U,N_x+1,N_y+1,1,G_SIDE_NONE,2,1); 
    g_hidden2(1.0, 1.0, 0.4, v_min, v_max,
	      5.0, 25.0, 30.0,
	      95.0, 20.0, 80.0, 60.0,
	      V,N_x+1,N_y+1,1,G_SIDE_NONE,2,1); 
    
    du = u_max - u_min;
    dv = v_max - v_min;
    
    /* printf("du=%g, dv=%g\n", du, dv); */
    
    for (m=0; m <= 10; m++){
      
      g_sel_scale(0);
      g_sel_line(1);
      g_contln2(0.0, 1.0, 0.0, 1.0, U, N_x+1, N_y+1, u_min + 0.1 * m * du);
      
      g_sel_scale(1);
      g_sel_line(2);
      g_contln2(0.0, 1.0, 0.0, 1.0, V, N_x+1, N_y+1, v_min + 0.1 * m * dv);

    }

    U_max[l]=u_max;
    V_max[l]=v_max;
    U_min[l]=u_min;
    V_min[l]=v_min;
    
    U_sum=V_sum=0.0;
    
    for(i=0;i<=N_x;i++)
      for(j=0;j<=N_y;j++){
	U_sum+=U[i][j];
	V_sum+=V[i][j];
      }
    
    U_ave[l]=U_sum/((N_x+1)*(N_y+1));
    V_ave[l]=V_sum/((N_x+1)*(N_y+1));
    
    g_sel_scale(2);
    drawSwing_max(U_max,V_max,l);
    
    g_sel_scale(3);
    drawSwing_min(U_min,V_min,l);
    
    g_sel_scale(4);
    drawSwing_ave(U_ave,V_ave,l);
    
    g_sel_scale(5);
    drawCycle(U_ave, V_ave, l);
	
    /* η׻ (ΰ u,x) */
    c1_u = 1.0 + 2.0 * lambda_x_u;
    c2_u = -lambda_x_u;
    c3_u = 1.0 - 2.0 * lambda_y_u;
    c4_u = lambda_y_u;
    printf("c1,c2,cu,c4=%g,%g,%g,%g\n", c1_u, c2_u, c3_u, c4_u);
    for (i = 1; i < N_x; i++) {
      alx_u[i] = c2_u; adx_u[i] = c1_u; aux_u[i] = c2_u;
    }
    alx_u[0] = 0; adx_u[0] = c1_u; aux_u[0] = 2 * c2_u;
    alx_u[N_x] = 2 * c2_u; adx_u[N_x] = c1_u; aux_u[N_x] = 0;
    
    /* η׻ ( u,y) --- ΰ x  y ؤ */
    c5_u = 1.0 + 2.0 * lambda_y_u;
    c6_u = -lambda_y_u;
    c7_u = 1.0 - 2.0 * lambda_x_u;
    c8_u = lambda_x_u;
    printf("c5,c6,c7,c8=%g,%g,%g,%g\n", c5_u, c6_u, c7_u, c8_u);
    for (j = 1; j < N_y; j++) {
      aly_u[j] = c6_u; ady_u[j] = c5_u; auy_u[j] = c6_u;
    }
    aly_u[0] = 0; ady_u[0] = c5_u; auy_u[0] = 2 * c6_u;
    aly_u[N_y] = 2 * c6_u; ady_u[N_y] = c5_u; auy_u[N_y] = 0;
    
    /* η׻ (λ v,x) --- ΰ u  v ؤ */
    c1_v = 1.0 + 2.0 * lambda_x_v;
    c2_v = -lambda_x_v;
    c3_v = 1.0 - 2.0 * lambda_y_v;
    c4_v = lambda_y_v;
    printf("c1,c2,c3,c4=%g,%g,%g,%g\n", c1_v, c2_v, c3_v, c4_v);
    for (i = 1; i < N_x; i++) {
      alx_v[i] = c2_v; adx_v[i] = c1_v; aux_v[i] = c2_v;
    }
    alx_v[0] = 0; adx_v[0] = c1_v; aux_v[0] = 2 * c2_v;
    alx_v[N_x] = 2 * c2_v; adx_v[N_x] = c1_v; aux_v[N_x] = 0;
    
    /* η׻ (λ v,y) --- λ x  y ؤ */
    c5_v = 1.0 + 2.0 * lambda_y_v;
    c6_v = -lambda_y_v;
    c7_v = 1.0 - 2.0 * lambda_x_v;
    c8_v = lambda_x_v;
    printf("c5,c6,c7,c8=%g,%g,%g,%g\n", c5_v, c6_v, c7_v, c8_v);
    for (j = 1; j < N_y; j++) {
      aly_v[j] = c6_v; ady_v[j] = c5_v; auy_v[j] = c6_v;
    }
    aly_v[0] = 0; ady_v[0] = c5_v; auy_v[0] = 2 * c6_v;
    aly_v[N_y] = 2 * c6_v; ady_v[N_y] = c5_v; auy_v[N_y] = 0;

    kmax = Tmax / tau + 0.5;
    printf("skip = %d\n", skip);
    
    /* LUʬ */
    trilu0(N_y + 1, aly_u, ady_u, auy_u);
    trilu0(N_x + 1, alx_u, adx_u, aux_u);
    trilu0(N_y + 1, aly_v, ady_v, auy_v);
    trilu0(N_x + 1, alx_v, adx_v, aux_v);

    /* ֤˴ؤ롼 */
    for (k = 1; k <= kmax; k++) {
      /*  U˴ؤkʤk1/2ʤޤǤϢΩ1 */
      for (j = 0; j <= N_y; j++) {
	double y = c + j * h_y;
	for (i = 0; i <= N_x; i++) {
	  double x = a + i * h_x;
	  if (j == 0)
	    ff[i] = c3_u * U[i][0]
	      + 2 * lambda_y_u * (U[i][1] + h_y * beta(x, c))
		+(tau/2)*F(U[i][0],V[i][0],f,q,epsilon);
	  else if (j == N_y)
	    ff[i] = c3_u * U[i][N_y]
	      + 2 * lambda_y_u * (U[i][N_y - 1] + h_y * beta(x, d))
		+(tau/2)*F(U[i][N_y],V[i][N_y],f,q,epsilon);
	  else
	    ff[i] = c3_u * U[i][j] + lambda_y_u * (U[i][j + 1] + U[i][j - 1])
	      +(tau/2)*F(U[i][j],V[i][j],f,q,epsilon);
	}
	ff[0]   += 2.0 * lambda_x_u * h_x * beta(a, y);
	ff[N_x] += 2.0 * lambda_x_u * h_x * beta(b, y);
	/* ϢΩ1 */
	trisol0(N_x + 1, alx_u, adx_u, aux_u, ff);
	/* 򵭲 */
	for (i = 0; i <= N_x; i++)
	  newU[i][j] = ff[i];
      }

      /*  V˴ؤkʤk1/2ʤޤǤϢΩ1 */
      for (j = 0; j <= N_y; j++) {
	double y = c + j * h_y;
	for (i = 0; i <= N_x; i++) {
	  double x = a + i * h_x;
	  if (j == 0)
	    ff[i] = c3_v * V[i][0]
	      + 2 * lambda_y_v * (V[i][1] + h_y * beta(x, c))
		+(tau/2)*G(U[i][0],V[i][0]);
	  else if (j == N_y)
	    ff[i] = c3_v * V[i][N_y]
	      + 2 * lambda_y_v * (V[i][N_y - 1] + h_y * beta(x, d))
		+(tau/2)*G(U[i][N_y],V[i][N_y]);
	  else
	    ff[i] = c3_v * V[i][j] + lambda_y_v * (V[i][j + 1] + V[i][j - 1])
	      +(tau/2)*G(U[i][j],V[i][j]);
	}
	ff[0]   += 2.0 * lambda_x_v * h_x * beta(a, y);
	ff[N_x] += 2.0 * lambda_x_v * h_x * beta(b, y);
	/* ϢΩ1 */
	trisol0(N_x + 1, alx_v, adx_v, aux_v, ff);
	/* 򵭲 */
	for (i = 0; i <= N_x; i++)
	  newV[i][j] = ff[i];
      }

      /* U˴ؤk+1/2ʤk+1ʤޤǤϢΩ1 */
      for (i = 0; i <= N_x; i++) {
	double x = a + i * h_x;
	for (j = 0; j <= N_y; j++) {
	  double y = c + j * h_y;
	  if (i == 0)
	    gg[j] = c7_u * newU[0][j]
	      + 2 * lambda_x_u * (newU[1][j] + h_x * beta(a, y))
		+(tau/2)*F(newU[0][j],newV[0][j],f,q,epsilon);
	  else if (i == N_x)
	    gg[j] = c7_u * newU[N_x][j]
	      + 2 * lambda_x_u * (newU[N_x - 1][j] + h_x * beta(b, y))
		+(tau/2)*F(newU[N_x][j],newV[N_x][j],f,q,epsilon);
	  else
	    gg[j] = c7_u * newU[i][j]
	      + lambda_x_u * (newU[i + 1][j] + newU[i - 1][j])
		+(tau/2)*F(newU[i][j],newV[i][j],f,q,epsilon);
	}
	gg[0]   += 2.0 * lambda_y_u * h_y * beta(x, c);
	gg[N_y] += 2.0 * lambda_y_u * h_y * beta(x, d);
	/* ϢΩ1 */
	trisol0(N_y + 1, aly_u, ady_u, auy_u, gg);
	/* 򵭲 */
	for (j = 0; j <= N_y; j++)
	  U[i][j] = gg[j];
      }
      
      /* V˴ؤk+1/2ʤk+1ʤޤǤϢΩ1 */
      for (i = 0; i <= N_x; i++) {
	double x = a + i * h_x;
	for (j = 0; j <= N_y; j++) {
	  double y = c + j * h_y;
	  if (i == 0)
	    gg[j] = c7_v * newV[0][j]
	      + 2 * lambda_x_v * (newV[1][j] + h_x * beta(a, y))
		+(tau/2)*G(newU[0][j],newV[0][j]);
	  else if (i == N_x)
	    gg[j] = c7_v * newV[N_x][j]
	      + 2 * lambda_x_v * (newV[N_x - 1][j] + h_x * beta(b, y))
		+(tau/2)*G(newU[N_x][j],newV[N_x][j]);
	  else
	    gg[j] = c7_v * newV[i][j]
	      + lambda_x_v * (newV[i + 1][j] + newV[i - 1][j])
		+(tau/2)*G(newU[i][j],newV[i][j]);
	}
	gg[0]   += 2.0 * lambda_y_v * h_y * beta(x, c);
	gg[N_y] += 2.0 * lambda_y_v * h_y * beta(x, d);
	/* ϢΩ1 */
	trisol0(N_y + 1, aly_v, ady_v, auy_v, gg);
	/* 򵭲 */
	for (j = 0; j <= N_y; j++)
	  V[i][j] = gg[j];
      }
      
      /* t Ȥ˥դ */
      if (k % skip == 0) {
	g_cls();

	t = tau * k;
	
	sprintf(message1,"f=%g, q=%g, steady=%g, epsilon=%g, b=%g, d=%g, Nx=%d, Ny=%d, Tmax=%g, dt=%g,",f,q,steady,epsilon,b,d,N_x,N_y,Tmax,dt);
	sprintf(message2,"nfunc=%d, t=%g",nfunc,t);
	g_sel_text(0);
	g_text(5.0,10.0,message1);
	g_text(5.0,20.0,message2);

	/*g_sel_text(1);
	  g_text(19,82,"0");
	  g_text(18,69,"1");
	  g_text(93,102,"1");
	  g_text(144,82,"0");
	  g_text(143,69,"1");
	  g_text(218,102,"1");*/

	u_min = u_max = U[0][0];
	v_min = v_max = V[0][0];
	for(i=0;i<=N_x;i++)
	  for(j=0;j<=N_y;j++){
	    if(U[i][j]>u_max)u_max=U[i][j];
	    if(U[i][j]<u_min)u_min=U[i][j];
	    if(V[i][j]>v_max)v_max=V[i][j];
	    if(V[i][j]<v_min)v_min=V[i][j];
	  }
	printf("u_max=%e,u_min=%e,v_max=%e,v_min=%e\n",u_max,u_min,v_max,v_min);
	
	g_hidden2(1.0, 1.0, 0.4, u_min, u_max,
		  5.0, 25.0, 30.0,
		  10.0, 20.0, 80.0, 60.0,
		  U,N_x+1,N_y+1,1,G_SIDE_NONE,2,1); 
	g_hidden2(1.0, 1.0, 0.4, v_min, v_max,
		  5.0, 25.0, 30.0,
		  95.0, 20.0, 80.0, 60.0,
		  V,N_x+1,N_y+1,1,G_SIDE_NONE,2,1); 

	du = u_max - u_min;
	dv = v_max - v_min;

	/* printf("du=%g, dv=%g\n", du, dv); */

	for (m=0; m <= 10; m++){

	  g_sel_scale(0);
	  g_sel_line(1);
	  g_contln2(0.0, 1.0, 0.0, 1.0, U, N_x+1, N_y+1, u_min + 0.1 * m * du);

	  g_sel_scale(1);
	  g_sel_line(2);
	  g_contln2(0.0, 1.0, 0.0, 1.0, V, N_x+1, N_y+1, v_min + 0.1 * m * dv);

	}

	l++;
	l=l%101;

	U_max[l]=u_max;
	V_max[l]=v_max;
	U_min[l]=u_min;
	V_min[l]=v_min;
	
	U_sum=V_sum=0.0;

	for(i=0;i<=N_x;i++)
	  for(j=0;j<=N_y;j++){
	    U_sum+=U[i][j];
	    V_sum+=V[i][j];
	  }

	U_ave[l]=U_sum/((N_x+1)*(N_y+1));
	V_ave[l]=V_sum/((N_x+1)*(N_y+1));

	g_sel_scale(2);
	drawSwing_max(U_max,V_max,l);

	g_sel_scale(3);
	drawSwing_min(U_min,V_min,l);

	g_sel_scale(4);
	drawSwing_ave(U_ave,V_ave,l);

	g_sel_scale(5);
	drawCycle(U_ave, V_ave, l);
      }

    }

    /* ޥǥåΤԤ */
    g_sleep(-1.0);
    /* ɥä */
    g_term();
    
    return 0;
}

double h(double r)
{
  if(r>=0.0 && r<=1.0)
    return (r*r-1)*(r*r-1);
  else
    return 0.0;
}

/* 濴ȾRλ */
double peak0(double x,double y,double R)
{
  return h(sqrt(x*x+y*y)/R);
}

/* (a,b)濴ȾRλ */
double peak(double x,double y,double a,double b,double R)
{
  return peak0(x-a,y-b,R);
}
 
double u0(double x,double y, double steady, double q, int nfunc)
{
  if (nfunc == 0)
    return 0.5+0.5*sin(PI*x)*sin(PI*y);
  else if (nfunc == 1) {
    if (x >= 0.5 && x <= 1.0 && y > 0.8 && y < 0.9)
      return 1.0;
    else
      return 0.2;
  }
  else if(nfunc == 2)
    return steady + 2 * q * peak(x, y, 0.5, 0.5, 0.05)
      -0.5*q*peak(x, y, 0.25, 0.5, 0.05)
      -0.5*q*peak(x, y, 0.75, 0.5, 0.05); 
  else if(nfunc == 3)
    return steady + peak(x, y, 0.5, 0.5, 0.1)
      + peak(x, y, 1.5, 0.5, 0.1)
      + peak(x, y, 0.5, 1.0, 0.1)
      + peak(x, y, 1.5, 1.0, 0.1);
  else if(nfunc == 4){
    if(x>=0.0 && x<=1.0 && y>=0.74 && y<=0.76)
      return steady+0.5;
    else 
      return steady;
  }
  else if(nfunc == 5)
    return 0.15 + peak(x, y, 0.5, 0.5, 0.2)
      + peak(x, y, 1.5, 0.5, 0.2)
      + peak(x, y, 0.5, 1.0, 0.2)
      + peak(x, y, 1.5, 1.0, 0.2);
  else if(nfunc == 6){
    if((x>=0.0 && x<=1.0 && y>=0.74 && y<=0.76) || (x>=0.98 && x<=1.0 && y>=0.64 && y<=0.74))
      return steady+0.5;
    else 
      return steady;
  }
  else if(nfunc == 7){
    if((x>=0.0 && x<=0.99 && y>=0.72 && y<=0.74) || (x>=1.01 && x<=2.0 && y>=0.76 && y<=0.78))
		return steady+0.5;
    else 
      return steady;
  }
  else if(nfunc == 8){
    if(x>=0.9 && x<=1.0 && y>=0.7 && y<=0.8)
      return steady+0.5;
    else
      return steady;
  }
  else if(nfunc == 9){
    if(x>=0.2 && x<=0.5 && y>=0.74 && y<=0.76)
      return steady+0.5;
    else 
      return steady;
  }
  
  return 0.0;
}

double v0(double x,double y, double steady, double q, int nfunc)
{
  if (nfunc == 0)
    return sin(PI*x)/2+sin(PI*y)/2+1;
  else if (nfunc == 1 || nfunc == 2 || nfunc == 3 || nfunc == 4 || nfunc == 5)
    return steady;
  else if(nfunc == 6){
    if(x>=1.0 && x<=1.02 && y>=0.76 && y<=0.86)
      return steady+0.5;
    else
      return steady;
  }
  else if(nfunc == 7){
    if((x>=0.0 && x<=0.99 && y>=0.74 && y<=0.75) || (x>=1.01 && x<=2.0 && y>=0.75 && y<=0.76))
      return steady+0.5;
    else
      return steady;
  }
  else if(nfunc == 8){
    if((x>=0.8 && x<=0.9 && y>=0.6 && y<=0.8) || (x>=0.9 && x<=1.1 && y>=0.6 && y<=0.7) || (x>=1.0 && x<=1.1 && y>=0.7 && y<=1.0) || (x>=0.6 && x<=1.0 && y>=0.9 && y<=1.0) || (x>=0.6 && x<=0.7 && y>=0.4 && y<=0.9) || (x>=0.7 && x<=1.3 && y>=0.4 && y<=0.5) || (x>=1.2 && x<=1.3 && y>=0.4 && y<=1.2))
      return steady+0.5;
    else
      return steady;
  } 
  else if(nfunc == 9){
    if((x>=0.0 && x<=0.1 && y>=0.0 && y<=1.5) || (x>=0.1 && x<=2.0 && y>=1.4 && y<=1.5) || (x>=1.9 && x<=2.0 && y>=0.0 && y<=1.4) || (x>=0.1 && x<=1.9 && y>=0.0 && y<=0.1))
      return steady+0.5;
    else 
      return steady+peak(x, y, 0.7, 0.75, 0.3);
  }
  
  return 0.0;
}

double beta(double x, double y)
{
  /*Ʊ Neumann  */
  /*return x * x - y * y;*/
  /* return 1.0;*/
  return 0.0;
}


/* 3 (󤬻гѤǤϢΩ1Τ) Ax=b 
 *
 *   
 *     n: ̤οθĿ
 *     al,ad,au: ϢΩ1η
 *       (al: гβ¦ i.e. ʬ (lower part)
 *        ad: г       i.e. гʬ (diagonal part)
 *        au: гξ¦ i.e. 廰ʬ (upper part)
 *        Ĥޤ
 *
 *         ad[0] au[0]   0   .................. 0
 *         al[1] ad[1] au[1]   0  ............. 0
 *           0   al[2] ad[2] au[2]  0 ......... 0
 *                         ....................
 *                         al[n-2] ad[n-2] au[n-2]
 *                           0     al[n-1] ad[n-1]

 *        al[i] = A_{i,i-1}, ad[i] = A_{i,i}, au[i] = A_{i,i+1},
 *        al[0], au[n-1] ϰ̣ʤ)
 *
 *     b: ϢΩ1αդδΥ٥ȥ
 *        (ź 0 顣i.e. b[0],b[1],...,b[n-1] ˥ǡäƤ롣)
 *   
 *     al,ad,au: Ϥ LU ʬ򤷤
 *     b: ϢΩ1β
 *   ǽ
 *      call ȷ LU ʬ򤷤Τ֤Τǡ
 *     ʸƱ˴ؤϢΩ1򤯤ˡ
 *     ؿ trisol() Ȥ롣
 *   
 *     Gauss ξõˡѤƤ뤬ԥܥåȤϤƤ
 *     ΤǡԥܥåȤ򤷤ƤʤΤǡͤǤ
 *     ʤɤŬڤʾ郎ʤϷ̤ݾڤǤʤ
 */

void trid0(int n, double *al, double *ad, double *au, double *b)
{
  trilu0(n,al,ad,au);
  trisol0(n,al,ad,au,b);
}

/* гѹ LU ʬ (pivoting ʤ) */
void trilu0(int n, double *al, double *ad, double *au)
{
  int i, nm1 = n - 1;
  /* ʾõ (forward elimination) */
  for (i = 0; i < nm1; i++) {
    al[i + 1] /= ad[i];
    ad[i + 1] -= au[i] * al[i + 1];
  }
}

/* LU ʬѤߤλгѹ򷸿˻3 */
void trisol0(int n, double *al, double *ad, double *au, double *b)
{
  int i, nm1 = n - 1;
  /* ʾõ (forward elimination) */
  for (i = 0; i < nm1; i++) b[i + 1] -= b[i] * al[i + 1];
  /*  (backward substitution) */
  b[nm1] /= ad[nm1];
  for (i = n - 2; i >= 0; i--) b[i] = (b[i] - au[i] * b[i + 1]) / ad[i];
}

double F(double u, double v, double f, double q, double epsilon)
{
#ifdef HEAT
  return 0.0;
#else
  return (u * (1 - u) - f * v * (u - q) / (u + q)) / epsilon;
#endif
}

double G(double u, double v)
{
#ifdef HEAT
  return 0.0;
#else
  return u - v; 
#endif
}

void drawSwing_max(double U_max[], double V_max[], int l)
{
  int i;
  g_sel_line(0);
  g_move(0.0,0.0); g_plot(1.0,0.0);
  g_move(0.0,0.0); g_plot(0.0,1.0);
  
  g_sel_line(1);
  g_move(0.0,U_max[0]);
  for(i=1;i<=l;i++)
    g_plot(i*0.01,U_max[i]);
  
  g_sel_line(2);
  g_move(0.0,V_max[0]);
  for(i=1;i<=l;i++)
    g_plot(i*0.01,V_max[i]);
}

void drawSwing_min(double U_min[], double V_min[], int l)
{
  int i;
  g_sel_line(0);
  g_move(0.0,0.0); g_plot(1.0,0.0);
  g_move(0.0,0.0); g_plot(0.0,1.0);
  
  g_sel_line(1);
  g_move(0.0,U_min[0]);
  for(i=1;i<=l;i++)
    g_plot(i*0.01,U_min[i]);
  
  g_sel_line(2);
  g_move(0.0,V_min[0]);
  for(i=1;i<=l;i++)
    g_plot(i*0.01,V_min[i]);
}

void drawSwing_ave(double U_ave[], double V_ave[], int l)
{
  int i;
  g_sel_line(0);
  g_move(0.0,0.0); g_plot(1.0,0.0);
  g_move(0.0,0.0); g_plot(0.0,1.0);
  
  g_sel_line(1);
  g_move(0.0,U_ave[0]);
  for(i=1;i<=l;i++)
    g_plot(i*0.01,U_ave[i]);
  
  g_sel_line(2);
  g_move(0.0,V_ave[0]);
  for(i=1;i<=l;i++)
    g_plot(i*0.01,V_ave[i]);
}

void drawCycle(double U_ave[], double V_ave[], int l)
{ 
  int i;
  g_sel_line(0);
  g_move(0.0,0.0); g_plot(1.0,0.0);
  g_move(0.0,0.0); g_plot(0.0,1.0);

  g_sel_line(3);
  g_move(U_ave[0],V_ave[0]);
  for(i=1;i<=l;i++)
    g_plot(U_ave[i],V_ave[i]);
}
